Loading...
Searching...
No Matches
Sip_error_info

## Data Structures

struct | sip_error_info_s
| Structure for Error-Info header. More...

## Macros

#define | sip_error_info(sip)
| Access a SIP Error-Info header structure sip_error_info_t from sip_t.
#define | SIP_ERROR_INFO_INIT()
| Initializer for structure sip_error_info_t.
#define | SIPTAG_ERROR_INFO(x)
| Tag list item for pointer to a Error-Info header structure sip_error_info_t.
#define | SIPTAG_ERROR_INFO_REF(x)
| Tag list item for reference to a Error-Info header pointer.
#define | SIPTAG_ERROR_INFO_STR(s)
| Tag list item for string with Error-Info header value.
#define | SIPTAG_ERROR_INFO_STR_REF(x)
| Tag list item for reference to a Error-Info header string.

## Typedefs

typedef struct sip_error_info_s | sip_error_info_t
| @

## Functions

issize_t | sip_error_info_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Error-Info header.
issize_t | sip_error_info_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Error-Info header.
sip_error_info_t * | sip_error_info_init (sip_error_info_t x[1])
| Initialize a structure sip_error_info_t.
int | sip_is_error_info (sip_header_t const *header)
| Test if header object is instance of sip_error_info_t.
sip_error_info_t * | sip_error_info_dup (su_home_t *home, sip_error_info_t const *hdr))
| Duplicate a list of Error-Info header header structures sip_error_info_t.
sip_error_info_t * | sip_error_info_copy (su_home_t *home, sip_error_info_t const *hdr))
| Copy a list of Error-Info header header structures sip_error_info_t.
sip_error_info_t * | sip_error_info_make (su_home_t *home, char const *s))
| Make a Error-Info header structure sip_error_info_t.
sip_error_info_t * | sip_error_info_format (su_home_t *home, char const *fmt,...)))
| Make a Error-Info header from formatting result.

## Variables

msg_hclass_t | sip_error_info_class []
| Header class for Error-Info header.
tag_typedef_t | siptag_error_info
| Tag for Error-Info header object.
tag_typedef_t | siptag_error_info_str
| Tag for string with Error-Info header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ERROR_INFO_INIT

#define SIP_ERROR_INFO_INIT | ( |  | ) |

Initializer for structure sip_error_info_t.

A static sip_error_info_t structure for Error-Info header must be initialized with the SIP_ERROR_INFO_INIT() macro. For instance,

sip_error_info_t sip_error_info = SIP_ERROR_INFO_INIT;
sip_error_info_t
struct sip_error_info_s sip_error_info_t
@
Definition sip.h:158
SIP_ERROR_INFO_INIT
#define SIP_ERROR_INFO_INIT()
Initializer for structure sip_error_info_t.
Definition sip_protos.h:10858
sip_error_info
#define sip_error_info(sip)
Access a SIP Error-Info header structure sip_error_info_t from sip_t.
Definition sip_protos.h:10841

## SIPTAG_ERROR_INFO

#define SIPTAG_ERROR_INFO | ( |  | x | ) |

Tag list item for pointer to a Error-Info header structure sip_error_info_t.

The SIPTAG_ERROR_INFO() macro is used to include a tag item with a pointer to a sip_error_info_t structure in a tag list.

Parameters

  x | pointer to a sip_error_info_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ERROR_INFO_REF().

## SIPTAG_ERROR_INFO_STR

#define SIPTAG_ERROR_INFO_STR | ( |  | s | ) |

Tag list item for string with Error-Info header value.

The SIPTAG_ERROR_INFO_STR() macro is used to include a tag item with a string containing value of a sip_error_info_t header in a tag list.

Parameters

  s | pointer to a string containing Error-Info header value, or NULL.

The string in SIPTAG_ERROR_INFO_STR() can be converted to a sip_error_info_t header structure by giving the string s has second argument to function sip_error_info_make().

The corresponding tag taking reference parameter is SIPTAG_ERROR_INFO_STR_REF().

## Typedef Documentation

## sip_error_info_t

typedef struct sip_error_info_s sip_error_info_t

@

The Error-Info header provides a pointer to additional information about the error status response. Its syntax is defined in RFC 3261 as follows:

Error-Info = "Error-Info" HCOLON error-uri *(COMMA error-uri)
error-uri = LAQUOT absoluteURI RAQUOT *( SEMI generic-param )

The parsed Error-Info header is stored in sip_error_info_t structure.

The structure sip_error_info_t contains representation of an Error-Info header.

The sip_error_info_t is defined as follows:

struct sip_error_info_s
{
sip_common_t ei_common[1]; // Common fragment info
sip_error_info_t *ei_next; // Link to next @ErrorInfo
url_t ei_url[1]; // URI to error info
msg_param_t const *ei_params; // List of parameters
};
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_error_info_s
Structure for Error-Info header.
Definition sip.h:524
sip_error_info_s::ei_url
url_t ei_url[1]
URI to error description.
Definition sip.h:527
sip_error_info_s::ei_common
sip_common_t ei_common[1]
Common fragment info.
Definition sip.h:525
sip_error_info_s::ei_params
msg_param_t const * ei_params
List of parameters.
Definition sip.h:528
sip_error_info_s::ei_next
sip_call_info_t * ei_next
Link to next Error-Info.
Definition sip.h:526
url_t

## Function Documentation

## sip_error_info_copy()

sip_error_info_t * sip_error_info_copy | ( | su_home_t * | home,
|  | sip_error_info_t const * | hdr )

inline

Copy a list of Error-Info header header structures sip_error_info_t.

The function sip_error_info_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  error_info = sip_error_info_copy(home, sip->sip_error_info);
  sip_error_info_copy
  sip_error_info_t * sip_error_info_copy(su_home_t *home, sip_error_info_t const *hdr))
  Copy a list of Error-Info header header structures sip_error_info_t.
  Definition sip_protos.h:10988

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_error_info_dup()

sip_error_info_t * sip_error_info_dup | ( | su_home_t * | home,
|  | sip_error_info_t const * | hdr )

inline

Duplicate a list of Error-Info header header structures sip_error_info_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  error_info = sip_error_info_dup(home, sip->sip_error_info);
  sip_error_info_dup
  sip_error_info_t * sip_error_info_dup(su_home_t *home, sip_error_info_t const *hdr))
  Duplicate a list of Error-Info header header structures sip_error_info_t.
  Definition sip_protos.h:10945

Returns
  A pointer to the newly duplicated sip_error_info_t header structure, or NULL upon an error.

## sip_error_info_format()

sip_error_info_t * sip_error_info_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Error-Info header from formatting result.

Make a new sip_error_info_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_error_info_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_error_info_init()

sip_error_info_t * sip_error_info_init | ( | sip_error_info_t | x[1] | ) |

inline

Initialize a structure sip_error_info_t.

An sip_error_info_t structure for Error-Info header can be initialized with the sip_error_info_init() function/macro. For instance,

sip_error_info_t sip_error_info;
sip_error_info_init(&sip_error_info);
sip_error_info_init
sip_error_info_t * sip_error_info_init(sip_error_info_t x[1])
Initialize a structure sip_error_info_t.
Definition sip_protos.h:10876

## sip_error_info_make()

sip_error_info_t * sip_error_info_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Error-Info header structure sip_error_info_t.

The function sip_error_info_make() makes a new sip_error_info_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_error_info_t header structure, or NULL upon an error.

## sip_is_error_info()

int sip_is_error_info | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_error_info_t.

Check if the header class is an instance of Error-Info header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header error_info
  0 | (false) otherwise

## Variable Documentation

## sip_error_info_class

msg_hclass_t sip_error_info_class[]

extern

Header class for Error-Info header.

The header class sip_error_info_class defines how a SIP Error-Info header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_error_info_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.